<?php
 
 
 

namespace PhpWA\Protocol\Proto\SessionStructure;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class Chain extends \Google\Protobuf\Internal\Message
{
    


    protected $senderRatchetKey = null;
    


    protected $senderRatchetKeyPrivate = null;
    


    protected $chainKey = null;
    


    private $messageKeys;

    











    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getSenderRatchetKey()
    {
        return isset($this->senderRatchetKey) ? $this->senderRatchetKey : '';
    }

    public function hasSenderRatchetKey()
    {
        return isset($this->senderRatchetKey);
    }

    public function clearSenderRatchetKey()
    {
        unset($this->senderRatchetKey);
    }

    




    public function setSenderRatchetKey($var)
    {
        GPBUtil::checkString($var, False);
        $this->senderRatchetKey = $var;

        return $this;
    }

    



    public function getSenderRatchetKeyPrivate()
    {
        return isset($this->senderRatchetKeyPrivate) ? $this->senderRatchetKeyPrivate : '';
    }

    public function hasSenderRatchetKeyPrivate()
    {
        return isset($this->senderRatchetKeyPrivate);
    }

    public function clearSenderRatchetKeyPrivate()
    {
        unset($this->senderRatchetKeyPrivate);
    }

    




    public function setSenderRatchetKeyPrivate($var)
    {
        GPBUtil::checkString($var, False);
        $this->senderRatchetKeyPrivate = $var;

        return $this;
    }

    



    public function getChainKey()
    {
        return $this->chainKey;
    }

    public function hasChainKey()
    {
        return isset($this->chainKey);
    }

    public function clearChainKey()
    {
        unset($this->chainKey);
    }

    




    public function setChainKey($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\SessionStructure\Chain\ChainKey::class);
        $this->chainKey = $var;

        return $this;
    }

    



    public function getMessageKeys()
    {
        return $this->messageKeys;
    }

    




    public function setMessageKeys($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \PhpWA\Protocol\Proto\SessionStructure\Chain\MessageKey::class);
        $this->messageKeys = $arr;

        return $this;
    }

}

